/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ead.poligonoprogetto;

import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.util.ArrayList;

/**
 *
 * @author Renato
 */
public class Poligono {

    // ArrayList dei vertici del poligono come oggetti Point2D.Double
    private ArrayList<Point2D.Double> vertici;

    // Costruttore con passaggio di un ArrayList di vertici (Point2D.Double)
    public Poligono(ArrayList<Point2D.Double> vert) {
        vertici = vert;

    }

    // Costruttore con passaggio di un vertice iniziale
    public Poligono(Point2D.Double point) {

        ArrayList<Point2D.Double> arr = new ArrayList<Point2D.Double>();
        arr.add(point);
        vertici = arr;
    }

    // Costruttore che instanzia un ArrayList vuoto di vertici
    public Poligono() {
        vertici = new ArrayList<Point2D.Double>();
    }

    // Costruttore che riceve un oggetto Polygon e lo "converte"
    public Poligono(Polygon pol) {
        vertici = new ArrayList<Point2D.Double>();
        for (int i = 0; i < pol.npoints; i++) {
            vertici.add(new Point2D.Double(pol.xpoints[i], pol.ypoints[i]));

        }

    }

    // Aggiunta di un vertice
    public void add(Point2D.Double aPoint) {
        vertici.add(aPoint);

    }

    // Restituzione del numero di vertici
    public int size() {
        return vertici.size();

    }

    // Calcolo del perimetro
    public double perimetro() {
        double perim = 0;
        if (size() > 0) {
            for (int i = 0; i < vertici.size() - 1; i++) {
                perim = perim + vertici.get(i).distance(vertici.get(i + 1));
            }
            perim = perim + vertici.get(vertici.size() - 1).distance(vertici.get(0));
        }
        return perim;

    }

    // Calcolo dell'area
    public double area() {
        double a = 0;
        if (size() > 0) {
            for (int i = 0; i < vertici.size() - 1; i++) {
                a = a + vertici.get(i).getX() * vertici.get(i + 1).getY() - vertici.get(i).getY() * vertici.get(i + 1).getX();

            }
            a = a + vertici.get(vertici.size() - 1).getX() * vertici.get(0).getY() - vertici.get(vertici.size() - 1).getY() * vertici.get(0).getX();
        }
        return 0.5 * Math.abs(a);

    }

    // Disegno del poligono
    public void draw(Graphics2D g2) {
        if (size() > 0) {
            for (int i = 0; i < vertici.size() - 1; i++) {
                Line2D.Double linea = new Line2D.Double(vertici.get(i), vertici.get(i + 1));
                g2.draw(linea);
            }
            Line2D.Double linea = new Line2D.Double(vertici.get(vertici.size() - 1), vertici.get(0));
            g2.draw(linea);
        }
    }

}
